package com.hisschemoller 
{
	import net.hires.debug.Stats;
	
	import com.hisschemoller.view.components.ARInfo;
	import com.hisschemoller.view.components.ARPV3D;
	import com.hisschemoller.view.components.audio.AudioEngine;
	
	import flash.display.Sprite;	

	/**
	 * Simple example of how to integrate FLARToolkit in PureMVC.
	 * There's one proxy which generates the augmented reality data from the webcam input
	 * and two views components: one is the basic pink cube on webcam video like 
	 * the example in the Saqoosha starterkit and another that displays numbers
	 * concerning the marker position.
	 * 
	 * @author Wouter Hisschemöller
	 * (c) Jul 29, 2009
	 */
	[SWF(width='460', height='280', frameRate='255', backgroundColor='0x112233')]
	public class App extends Sprite 
	{
		public var mARVideo : ARPV3D;
		public var mARInfo : ARInfo;
		public var mAudioEngine : AudioEngine;
		
		public function App()
		{
			initUI();
			
			var facade : AppFacade = AppFacade.getInstance();
			facade.startup(this);
		}

		/**
		 * 
		 */
		private function initUI() : void
		{
			mARVideo = new ARPV3D();
			mARVideo.x = 20;
			mARVideo.y = 20;
			addChild(mARVideo);
			
			mARInfo = new ARInfo();
			mARInfo.x = 340;
			mARInfo.y = 20;
			addChild(mARInfo);
			
			var stats : Stats = new Stats({ bg: 0x001122 });
			stats.x = 370;
			stats.y = 160;
			addChild(stats);
			
			mAudioEngine = new AudioEngine();
		}
	}
}
