package com.hisschemoller.controller 
{
	import com.hisschemoller.App;
	import com.hisschemoller.model.FLARProxy;
	import com.hisschemoller.view.ARInfoMediator;
	import com.hisschemoller.view.ARPV3DMediator;
	import com.hisschemoller.view.AudioEngineMediator;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;	
	/**
	 * @author Wouter Hisschemöller
	 * (c) Jul 31, 2009
	 */
	public class StartupCommand extends SimpleCommand implements ICommand 
	{
		override public function execute(inNote : INotification) : void
		{
			var app : App = inNote.getBody() as App;
			
			facade.registerProxy(new FLARProxy());
			
			facade.registerMediator(new AudioEngineMediator(app.mAudioEngine));
			facade.registerMediator(new ARPV3DMediator(app.mARVideo));
			facade.registerMediator(new ARInfoMediator(app.mARInfo));
		}
	}
}
