package com.hisschemoller.view 
{
	import com.hisschemoller.model.FLARProxy;
	import com.hisschemoller.model.vo.FLARResultVO;
	import com.hisschemoller.view.components.ARPV3D;

	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;	
	/**
	 * @author Wouter Hisschemöller
	 * (c) Aug 2, 2009
	 */
	public class ARPV3DMediator extends Mediator implements IMediator 
	{
		public static const NAME : String = "ARVideoMediator";

		public function ARPV3DMediator(inViewComponent : Object)
		{
			super(NAME, inViewComponent);
		}

		/**
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [ FLARProxy.TRANSFORM_3D_UPDATE,
					 FLARProxy.START ];
		}

		/**
		 * 
		 */
		override public function handleNotification(inNote : INotification) : void
		{
			switch(inNote.getName()) 
			{
				case FLARProxy.TRANSFORM_3D_UPDATE:
					video.update(inNote.getBody() as FLARResultVO);
					break;
				case FLARProxy.START:
					var flarProxy : FLARProxy = facade.retrieveProxy(FLARProxy.NAME) as FLARProxy;
					video.start(flarProxy.getParam(), flarProxy.getBitmap(), flarProxy.getWidth(), flarProxy.getHeight());
					break;
			}
		}

		/**
		 * 
		 */
		private function get video() : ARPV3D
		{
			return viewComponent as ARPV3D;
		}
	}
}
