package com.hisschemoller.view.components 
{
	import com.hisschemoller.model.vo.FLARResultVO;
	
	import org.libspark.flartoolkit.core.FLARSquare;
	import org.libspark.flartoolkit.core.labeling.FLARLabelingLabel;
	
	import flash.display.Sprite;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFormat;	
	/**
	 * @author Wouter Hisschemöller
	 * (c) Aug 2, 2009
	 */
	public class ARInfo extends Sprite 
	{
		private var mTextField : TextField;
		private var mTextFormat : TextFormat;

		public function ARInfo()
		{
			initUI();
		}

		/**
		 * 
		 */
		public function update(inResultVO : FLARResultVO) : void
		{
			if(inResultVO)
			{
				mTextField.text = "3D X = " + inResultVO.resultMat.m03.toFixed(2) 
				+ "\n3D Y = " + inResultVO.resultMat.m13.toFixed(2) 
				+ "\n3D Z = " + inResultVO.resultMat.m23.toFixed(2) 
				+ "\n\n2D X = " + inResultVO.square.label.pos_x 
				+ "\n2D Y = " + inResultVO.square.label.pos_y
				+ "\n\n2D rel X = " + inResultVO.relativeX.toFixed(2)
				+ "\n2D rel Y = " + inResultVO.relativeY.toFixed(2);
			}
			else
			{
				mTextField.text = "no input";
			}
			
			mTextField.setTextFormat(mTextFormat);
		}

		/**
		 * 
		 */
		private function initUI() : void
		{
			mTextFormat = new TextFormat();
			mTextFormat.font = "Verdana";
			mTextFormat.size = 10;
			mTextFormat.bold = true;
			
			mTextField = new TextField();
			mTextField.width = 100;
			mTextField.height = 140;
			mTextField.background = true;
			mTextField.backgroundColor = 0xCCDDEE;
			//mTextField.border = true;
			//mTextField.borderColor = 0x778899;
			mTextField.multiline = true;
			mTextField.wordWrap = true;
			mTextField.antiAliasType = AntiAliasType.ADVANCED;
			addChild(mTextField);
		}
	}
}
