package com.hisschemoller.view.components 
{
	import com.hisschemoller.model.vo.FLARResultVO;

	import org.libspark.flartoolkit.core.param.FLARParam;
	import org.libspark.flartoolkit.pv3d.FLARBaseNode;
	import org.libspark.flartoolkit.pv3d.FLARCamera3D;
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.render.LazyRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;

	import flash.display.Bitmap;
	import flash.display.Sprite;	
	/**
	 * @author Wouter Hisschemöller
	 * (c) Jul 29, 2009
	 */
	public class ARPV3D extends Sprite 
	{
		private var mViewport : Viewport3D;
		private var mCamera3d : FLARCamera3D;
		private var mScene3D : Scene3D;
		private var mRenderer : LazyRenderEngine;
		private var mFLARBaseNode : FLARBaseNode;
		private var mPlane : Plane;
		private var mCube : Cube;

		public function ARPV3D()
		{
			// nothing to do here
		}

		/**
		 * 
		 */
		public function start(inParam : FLARParam, inBitmap : Bitmap, inWidth : int, inHeight : int) : void
		{
			initUI(inParam, inBitmap, inWidth, inHeight);
		}

		/**
		 * 
		 */
		public function update(inResultVO : FLARResultVO) : void
		{
			if(inResultVO) 
			{
				mFLARBaseNode.setTransformMatrix(inResultVO.resultMat);
				mFLARBaseNode.visible = true;
			} 
			else 
			{
				mFLARBaseNode.visible = false;
			}
			
			mRenderer.render();
		}

		/**
		 * 
		 */
		private function initUI(inParam : FLARParam, inBitmap : Bitmap, inWidth : int, inHeight : int) : void
		{
			// mirror the view
			scaleX = -1;
			x += inWidth;
			
			graphics.lineStyle(1, 0x222222);
			graphics.drawRect(0, 0, inWidth, inHeight);
			graphics.lineTo(inWidth, inHeight);
			graphics.moveTo(0, inHeight);
			graphics.lineTo(inWidth, 0);
			
			addChild(inBitmap);
			
			mViewport = new Viewport3D(inWidth, inHeight);
			addChild(mViewport);
			
			mFLARBaseNode = new FLARBaseNode();
			
			mScene3D = new Scene3D();
			mScene3D.addChild(mFLARBaseNode);
			
			var wMat : WireframeMaterial = new WireframeMaterial(0xff0000, 1, 2);
			
			mPlane = new Plane(wMat, 80, 80);
			mPlane.rotationX = 180;
			mFLARBaseNode.addChild(mPlane);
			
			var light : PointLight3D = new PointLight3D();
			light.x = 0;
			light.y = 1000;
			light.z = -1000;
			
			var fMat : FlatShadeMaterial = new FlatShadeMaterial(light, 0xff22aa, 0x75104e);
			
			mCube = new Cube(new MaterialsList({all: fMat}), 40, 40, 40);
			mCube.z = 20;
			mFLARBaseNode.addChild(mCube);
			
			mCamera3d = new FLARCamera3D(inParam);
			mRenderer = new LazyRenderEngine(mScene3D, mCamera3d, mViewport);
		}
	}
}
